//+------------------------------------------------------------------+
//|                                               PriceHistogram.mq5 |
//|                                      Copyright vdv_2001 Software |
//|                                                 vdv_2001@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Dmitry Voronkov"
#property link      "vdv_2001@mail.ru"
#property version   "1.00"

#property description "   ( )."
#property description "         .         ."
#property description "The indicator Price histogram (Market profile)."
#property description "The indicator shows where the market will be most convenient for trade. For his application use of alarm indicators or oscillators is necessary."

#include "ClassExpert.mqh"
//    / The block input parameters
input int         DayTheHistogram   = 10;          //    / Days The Histogram
input int         DaysForCalculation= 500;          //   (-1 ) / Days for calculation(-1 all)
input int        RangePercent      = 70;          //   / Range%
input color       InnerRange        =Indigo;       //   / Inner range
input color       OuterRange        =Magenta;      //   / Outer range
input color       ControlPoint      =Orange;       //  (POC) / Point of Control
input bool        ShowValue         =true;         //   / Show Value

//   / Class variable
CExpert ExtExpert;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
//       / We check tool synchronisation before the beginning of accounts
   int err=0;
   while(!(bool)SeriesInfoInteger(Symbol(),0,SERIES_SYNCHRONIZED) && err<AMOUNT_OF_ATTEMPTS)
     {
      Sleep(500);
      err++;
     }
//   CExpert / Initialization of class CExpert
   ExtExpert.RangePercent=RangePercent;
   ExtExpert.InnerRange=InnerRange;
   ExtExpert.OuterRange=OuterRange;
   ExtExpert.ControlPoint=ControlPoint;
   ExtExpert.ShowValue=ShowValue;
   ExtExpert.DaysForCalculation=DaysForCalculation;
   ExtExpert.DayTheHistogram=DayTheHistogram;
   ExtExpert.Init();
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   ExtExpert.Deinit(reason);
  }
//+------------------------------------------------------------------+
//| Expert Tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   ExtExpert.OnTick();
  }
//+------------------------------------------------------------------+
//| Expert Event function                                            |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,         //    
                  const long& lparam,   //    long
                  const double& dparam, //    double
                  const string& sparam) //    string
  {
   ExtExpert.OnEvent(id,lparam,dparam,sparam);
  }
//+------------------------------------------------------------------+
//| Expert Timer function                                            |
//+------------------------------------------------------------------+
void OnTimer()
  {
   ExtExpert.OnTimer();
  }
//+------------------------------------------------------------------+
